ALTER PROCEDURE PRINTCHECKBYDOC (
    idmain integer,
    iduser integer,
    computername char(30),
    idpaylist integer,
    summamoney numeric(15,3),
    kkm_printonlysumma integer,
    kkm_printrates integer,
    headerstring char(256),
    footerstring char(256),
    kindcheck integer = 1)
as
declare variable idprintqueue integer;
declare variable datedoc date;
declare variable datebegin date;
declare variable idserviceold integer;
declare variable isweight integer;
declare variable ndocold integer;
declare variable idprinter integer;
declare variable idrealprinter integer;
declare variable notfirstrecord integer;
declare variable iddevision integer;
declare variable command integer;
declare variable line char(100);
declare variable nomertable integer;
declare variable summadiscountbydoc numeric(15,2);
declare variable idparent integer;
declare variable idservice integer;
declare variable summabyndoc numeric(15,2);
declare variable summabyservice numeric(15,2);
declare variable dateorder date;
declare variable summabydoc numeric(15,2);
declare variable servingout integer;
declare variable fullname_tmp char(100);
declare variable fullname char(100);
declare variable quantity numeric(15,3);
declare variable summatipbyrow numeric(15,2);
declare variable edvolume char(5);
declare variable volume numeric(15,3);
declare variable price numeric(15,2);
declare variable ndocaccount char(10);
declare variable ndocorder integer;
declare variable pricebyspr numeric(15,2);
declare variable summaadvances numeric(15,2);
declare variable summabyrow numeric(15,2);
declare variable summabysprbyrow numeric(15,2);
declare variable summadiscountbyrow numeric(15,2);
declare variable summa numeric(15,2);
declare variable summadiscount numeric(15,2);
declare variable cashername char(50);
declare variable subjectname char(50);
declare variable subjectaddress char(50);
declare variable subjectinn char(15);
declare variable nameservice char(50);
declare variable namedevision char(50);
declare variable namebenefit char(50);
declare variable cardcode char(25);
declare variable numcolumn integer;
declare variable commandnormalfont integer;
declare variable commandbigfont integer;
declare variable commandboldfont integer;
declare variable commandsmallfont integer;
declare variable ndoc char(10);
begin
  IdPrinter = 0;
  summabydoc = 0;
  summadiscountbydoc = 0;
  summa = 0;

  ndoc = 0;
  /*     */
  select max(r.id) from restaurant_stations s
  left outer join restaurant_printers r on r.idstation = s.Id
  where  s.computername = :computername and  r.ischeckprinter = 1 and r.status >= 0 into :IdPrinter;

  /*    */
  select r1.id from restaurant_printers r
    left outer join restaurant_printers r1 on r1.id = r.idrealprinter where r.id =  :IdPrinter
    into  :IdRealPrinter;

  if (IdRealPrinter >0) then
    idPrinter = IdRealPrinter;

  if ((IdPrinter = 0 ) or (IdPrinter is null))  then
    begin
       exception EX_RESTAURANT_NOTFINDPRINTER;
    end
  else
    begin
        /*   ( , */
        select coalesce(m.numcolumns,0),coalesce(m.commandnormalfont,0), coalesce(m.commandbigfont,0),
           coalesce(m.commandboldfont,0),coalesce(m.commandsmallfont,0)
           from restaurant_printers p
           left outer join restaurant_printermodels m on m.id = p.idmodel
           where p.id = :idprinter
           into :numcolumn,:commandnormalfont, :commandbigfont, :commandboldfont,:commandsmallfont ;
           if (numcolumn = 0) then
            numcolumn = 42;
           if (commandbigfont = 0) then
            commandbigfont = 56;
           if (commandboldfont = 0) then
            commandboldfont = 57;                               
           if (commandnormalfont = 0) then
            commandnormalfont = 64;
           if (commandsmallfont = 0) then
            commandsmallfont = 65;

            select gen_id(RESTAURANT_PRINTQUEUE,1) from setting into :IdPrintQueue;
        /*     */
        select m.Ndoc, m.DateDoc, c.Name, c.Inn , udf_left(c.Address,50)
            from main m
            left outer join commonspr c on c.id = m.idsubject
             where m.id = :idMain into :ndoc,:DateDoc,:SubjectName,:subjectinn, :SubjectAddress;
        Select u.UserName from users u where id = :iduser into :CasherName;
            if (ndoc = '') then
            ndoc = cast(idmain as Char(10));
            /*     (1- )*/
            command = 69;
            Line = '1';
            insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
            (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);

            /**/
            command = commandbigfont;
            Line = udf_padc(Trim(SubjectName),' ',cast(numcolumn/1.5 as integer));
            insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
            (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);

            /**/
            command = commandbigfont;
            Line = ' '||udf_padc(Trim(subjectinn),' ',cast(numcolumn/1.5 as integer));
            insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
            (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);

            /**/
            command = commandbigfont;
            Line = udf_padc(Trim(subjectaddress),' ',cast(numcolumn/1.5 as integer));
            insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
            (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);

            /* */
            command = commandnormalfont;
            line = ' ';
            insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
            (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);


            command = commandnormalfont;
            Line = ' : '||NDoc || udf_formatdatetime('dd.mm.yyyy',datedoc);
            insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
            (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);

            command = commandnormalfont;
            Line = ': '|| Trim(udf_left(CasherName,40));
            insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
            (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);

            command = commandnormalfont;
            line = udf_padl('--','-',numcolumn);
            insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
            (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);

        /*    */
        for select udf_left(l.fullname,100), d.cenaprice, d.cena, d.notdel,
           sum(d.kol) , sum(d.summa), sum(d.cenaprice * d.kol)
             from doc  d
            left outer join label l on l.id = d.idlabel
            where d.idDoc = :IdMain
            group by l.fullname, d.cenaprice, d.cena, d.notdel
            order by l.fullname
            into
            :fullname,  :PriceBySpr, :price, :idservice,
            :quantity, :summabyrow, :summabysprbyrow do
        begin
            command = commandnormalfont;
          fullname_tmp = Trim(fullname);
            Line = udf_left(fullname_tmp, numcolumn - 22)|| udf_padl(udf_FormatFloat('0',quantity),' ',3)||'x'||udf_padl(udf_FormatFloat('0.00',pricebyspr),' ',8)||'='||udf_padl(udf_FormatFloat('# ##0.00',summabysprbyrow),' ',9);
            command = commandnormalfont;
            insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
            (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);

            if (udf_length(Trim(fullname_tmp)) > (numcolumn - 22)) then
               begin
                command = commandnormalfont;
                line = TRIM(UDF_copy(fullname_tmp,numcolumn - 21,100));
                insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
                (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);
               end
            summadiscountbydoc = summadiscountbydoc + summabysprbyrow - summabyrow;
            summabydoc = summabydoc +  summabysprbyrow;
            summa = summa +  summabyrow;
        end
       /*   */
       command = commandnormalfont;
       line = udf_padl('','.',numcolumn);
       command = commandboldfont;
       line = ':'||udf_padl(udf_FormatFloat('# ##0.00',summabydoc),'.',numcolumn-6);
       insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
       (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);
       if (summadiscount <> 0) then
        begin
           command = commandboldfont;
           line = ':'||udf_padl(udf_FormatFloat('# ##0.00',summadiscount),'.',numcolumn-7);
           insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
           (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);

           command = commandnormalfont;
           line = ' ';
           insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
           (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);
    
           command = commandbigfont;
           line = ':'||udf_padl(udf_FormatFloat('# ##0.00',summa),'.',cast(numcolumn/1.5 as integer)-6);
           insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
           (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);
       end

       line = ':'||udf_padl(udf_FormatFloat('# ##0.00',summamoney),'.',cast(numcolumn/1.5 as integer)-9);
       insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
       (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);
       line = ' ';
       insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
       (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);

       if  ((summamoney-summa) > 0) then
        begin
           line = ':'||udf_padl(udf_FormatFloat('# ##0.00',summamoney-summa),'.',cast(numcolumn/1.5 as integer)-6);
           insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
           (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);
        end
        command = commandnormalfont;
        line = ' ';
        insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
        (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);
        command =  commandsmallfont;
        line = ' ';
        insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
        (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);
        command =  commandsmallfont;
        line = ' ';
        insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
        (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);
        command =  commandsmallfont;


        line = ': '||idprintqueue||' :' ||udf_formatdatetime('dd.mm.yy hh:nn:ss',current_timestamp);
        insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
        (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);
        command = commandnormalfont;
        line = ' ';

        insert into restaurant_printqueueitems (Id,IDPRINTQUEUE,Command,Line) values
        (gen_id(restaurant_printqueueitems,1),:IDPRINTQUEUE,:command,:Line);
       /*   */
       insert into restaurant_printqueue (Id,IDPRINTER,iduser,idmain,datebegin,Status)
       values (:idprintqueue,:idprinter,:iduser,:idmain,current_timestamp,0);
    end
end
